from .func_base import SessionFunctionBase, Token, User, hasher


class Get(SessionFunctionBase):
	def config(self, key, default=None):
		cache = self.cache.config.fetch(key)

		if cache:
			return cache

		row = self.s.fetch('config', key=key)

		if not row:
			value = default or self.defaults[key][0]

		else:
			value = self.defaults[key][1](row.value)

		self.cache.config.store(key, value)
		return value


	def configs(self):
		data = DotDict()

		for key in self.defaults:
			data[key] = self.config(key)

		return data


	def password(self, handle, password):
		user = self.user(handle)
		return hasher.verify(user.password, password)


	def token(self, code):
		cache = self.cache.token.fetch(code)

		if cache:
			return cache

		row = self.s.fetch('token')

		if not row:
			return

		token = Token(self.db, row)
		self.cache.token.store(token, token)
		return token


	def user(self, handle):
		handle = handle.lower()
		cache = self.cache.user.fetch(handle)

		if cache:
			return cache

		row = self.s.fetch('user', handle=handle)

		if not row:
			return

		user = User(self.db, row)
		self.cache.token.store(handle, user)
		return user
