import argparse, sys

from izzylib import logging

from .database import db, version


class Commands:
	def __getitem__(self, key):
		return getattr(self, f'command_{key}')


	def command_setup(self, *args):
		db.create_database()
		db.put('config', 'version', version)
		logging.info('Created database')


	def command_migrate(self, *args):
		pass


if __name__ == '__main__':
	parser = argparse.ArgumentParser()
	parser.add_argument(dest='command', help='The management command to run')
	parser.add_argument(dest='args', nargs='*', help='Arguments to pass to the management command')

	args = parser.parse_args()
	cmd = Commands()

	try:
		command = cmd[args.command]
	except AttributeError:
		logging.error('Invalid management command:', args.command)
		sys.exit()

	command(*args.args)
