from izzylib.http_server import MiddlewareBase, Response

from .database import db


auth_paths = [
	'/login',
	'/register'
]

reg_paths = [
	'/account',
	'/admin',
	'/logout'
]


class LoginDetect(MiddlewareBase):
	async def handler(self, request):
		response = Response(self.app, request)
		code = request.cookies.get('token')
		token = db.get('token', code)

		if token and token.user:
			request.ctx.token = token
			request.ctx.user = token.user
			request.user_level = token.user.level

		else:
			request.ctx.token = None
			request.ctx.user = None

		if any(map(request.path.startswith, reg_paths)) and not token:
			return response.redir('/login')

		if (any(map(request.path.startswith, auth_paths))) and token and token.user:
			return response.redir('/account')
